<?php
/*
	Finally an API !!
*/

// Calm down error reporting
error_reporting(E_ALL&~E_NOTICE);

require_once('config/db_config.php');
require_once('inc/functions.php');
require_once('inc/mysql_class.php');

// MySQL init
$cnx = new MysqlThing($db_host, $db_user, $db_pass, $db_database);

// Start a return array
$r = array ("code" => 0);

// Escape vars
foreach ($_POST AS $k => $v) {
	//$vars[$k] = $cnx->escape($v);
	if ($k == "email") {
		$vars['email'] = $cnx->escape($v);
	} else {
		$vars[$k] = $v;
	}
}

// JSON header
//header('Content-Type: application/json');
header('Content-type:application/json;charset=utf-8');

// Let's use `switch` !
switch($vars['cmd']) {

	case "newpass":
		// Change user password - requires: email, currpass, newpass

		// Check if we even have required data: - TODO/FIXME check if email is an email
		if ($vars['email'] AND $vars['currpass'] AND $vars['newpass']) {

			// Check if the password is correct 1st !
			$data = $cnx->select_row("uid, email, password", "view_users", "WHERE `email` = '".$vars['email']."';");
			preg_match('#{(.*)}(.*)#',$data['password'], $password_data); // Thanks konrados

			// Retro compatible - Check PLAIN-MD5 passwords
			if ($password_data[1] == "PLAIN-MD5") {
				if (md5($vars['currpass']) == $password_data[2]) {
					$logged_in = 1;
				}
			} else {
				if (password_verify($vars['currpass'], $password_data[2])) {
					$logged_in = 1;
				}
			}

			if ($logged_in) {
				// Fixup vars
				$vars_newpass['uid'] = $data['uid'];
				$vars_newpass['password'] = crypt_password($vars['newpass']);

				// Update
				$q = $cnx->update($vars_newpass, "virtual_users", $vars_newpass['uid']);

				if ($q) {
					$r['code'] = 1;
				} else {
					$r['error'] = "DB update error";
				}

			} else {
				$r['error'] = "Wrong password";
			}

		} else {
			$r['error'] = "Missing data";
		}

	break;
}

// return result
echo json_encode($r);

?>
